<template>
  <div class="page-add-food">
    <app-header :sticky="true">
      <template slot="options">
        <li @click="showExtraMeals = !showExtraMeals">
          <span v-if="showExtraMeals">عدم نمایش وعده های اضافی</span>
          <span v-else>نمایش وعده های اضافی</span>
        </li>
      </template>
    </app-header>
    <div class="app-body">
      <div class="page-header bg-gradient-primary">
        <h5 class="text-center">
          <span>خوراکی های</span>
          <span>{{ dateMoment.format('dddd jDD jMMMM ماه') }}</span>
        </h5>
        <div class="mt-4 the-container">
          <div class="d-flex justify-content-between font-7">
            <div>
              <span>کالری روزانه:</span>
              <span
                v-if="loadingProgress"
                class="loading d-inline-block vm"
                style="width: 28px"
              />
              <template v-else>
                <span>{{ progress.total }}</span>
                <span>کالری</span>
              </template>
            </div>
            <div>
              <span>کالری دریافتی:</span>
              <count-to :value="progress.used" />
              <span>کالری</span>
            </div>
          </div>
          <div class="progress">
            <div
              class="progress-bar"
              :class="progress.percentage > 100 ? 'bg-warning' : 'bg-success'"
              :style="{ width: `${progress.percentage}%` }"
            />
          </div>
        </div>
      </div>
      <div class="the-container">
        <loader :loading="loading" class="meals-list">
          <transition-group name="fade" tag="div">
            <meal-item
              v-for="(meal, i) in meals"
              :key="meal.type"
              :meal="meal"
              :index="i"
              :data-extra="meal.$data.isExtra"
              @add="addMealId = meal.id"
            />
          </transition-group>
        </loader>
      </div>
    </div>
    <add-food-modal :active.sync="addMealId" @submit="addFood" />
  </div>
</template>

<script>
import '../../assets/sass/pages/add-food.scss'
import AddFoodModal from './AddFoodModal'
import MealItem from './MealItem'

export default {
  name: 'AddFood',
  components: { AddFoodModal, MealItem },
  syncSettings: [{ showExtraMeals: false }],
  data() {
    return {
      loading: false,
      loadingProgress: false,

      // this will update after component loaded
      todayTotalCalorie: 0,

      // save day used calorie
      // the used calorie before we enter to this page
      usedCalorieOld: null,

      addMealId: null,
      date: ''
    }
  },
  computed: {
    dateMoment() {
      return this.$moment(this.date)
    },
    meals: {
      get() {
        let meals = this.$store.getters['food/dayFoods'](this.date)

        if (this.showExtraMeals) return meals

        return meals.filter(meal =>
          meal.$data.isExtra ? this.showExtraMeals : true
        )
      },
      set(val) {
        this.$store.commit('food/updateDayFoods', {
          date: this.date,
          data: val
        })
      }
    },
    progress() {
      let total = this.todayTotalCalorie,
        used = 0
      this.meals.forEach(meal => {
        used += meal.foods.map(f => f.calorie).reduce((a, b) => a + b, 0)
      })
      let percentage = total === 0 ? 0 : Math.floor((used / total) * 100)

      // update the usedCalorieOld for first time only
      if (this.usedCalorieOld === null) {
        // eslint-disable-next-line
        this.usedCalorieOld = used
      }

      return { total, used, percentage }
    }
  },
  watch: {
    showExtraMeals(val) {
      if (val)
        this.$nextTick(() => {
          try {
            document
              .querySelector('[data-extra="true"]')
              .scrollIntoView({ behavior: 'smooth', block: 'center' })
          } catch (e) {
            // eslint-disable-next-line
            console.error(e)
          }
        })
    }
  },
  created() {
    let date = this.$route.query.date
    if (!date) {
      date = this.$moment().format('YYYY-MM-DD')
    }
    this.date = date
    this.getDayFoods()
    this.getDayCalorie()
  },
  methods: {
    getDayFoods() {
      //if (this.$store.state.food.dayFoods[this.date]) return
      this.$store.dispatch('food/getDayFoods', {
        $vm: this,
        $data: {
          date: this.date
        }
      })
    },
    getDayCalorie() {
      let dayPlan = this.$store.getters['home/plans'][this.date]

      if (dayPlan) {
        return (this.todayTotalCalorie = dayPlan.goalCalories)
      }

      this.$store
        .dispatch('home/getDashboard', {
          $vm: this,
          $mainLoading: false,
          $loadingKey: 'loadingProgress',
          $data: {
            date: this.date
          }
        })
        .then(this.getDayCalorie)
    },
    addFood(data) {
      let mealId = this.addMealId

      // close the addFood modal
      this.addMealId = null

      this.$store.commit('food/addTemporaryFood', {
        ...data,
        mealId,
        date: this.date
      })
    }
  },
  beforeRouteLeave(to, from, next) {
    // if added a food or any changes are made
    // then we will rest the day data from store/home/plans
    if (this.usedCalorieOld !== this.progress.used) {
      this.$store.commit('home/resetDay', this.date)
    }
    next()
  }
}
</script>
